/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Description: 通讯组件（CM）event异步调用 服务端示例程序
 */

#include "server_activity.h"
#include "image.h"
#include "ara/log/logging.h"
#include "ara/exec/execution_client.h"

void ThreadAct()
{
    ServerActivity server;
    printf("here %d\n\n\n", __LINE__);

    server.Init() ;

    Image image;
    image.setInputParams(8, "mdc_camera_instance_4", 0, "cam4Sample" ,true);

    image.Init();
    //image.OnInit();
    printf("here %d\n\n\n", __LINE__);
    //image.OnInit();
    image.OnInit();
    while (1) {
        //server.Act();
        const uint32_t actGapTime = 2U;
        std::this_thread::sleep_for(std::chrono::seconds(actGapTime));
    }
}

int main()
{
    ara::log::InitLogging("DEAS", "CM_DDS_EVENT_ASYNC_SERVER_SAMPLE", ara::log::LogLevel::kVerbose,
        (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));

    ara::exec::ExecutionClient execClient;
    execClient.ReportExecutionState(ara::exec::ExecutionState::kRunning);

    ara::log::Logger& mainLog {ara::log::CreateLogger("main", "cm sample context", ara::log::LogLevel::kVerbose)};

    mainLog.LogInfo() << "Let's produce some camera data...";

    std::thread act(ThreadAct);
    act.join();

    mainLog.LogInfo() << "Done.";
    execClient.ReportExecutionState(ara::exec::ExecutionState::kTerminating);
    return 0;
}
